package com.eneraptor.hci

import grails.converters.*

class LogicRequestController {

	def reportService
	def hciLogicCommService
	
    def testConnection = {
		
		def output = "";
		output += reportService.println("Conection test using")
		output += reportService.println("Logic IP address: " + session.hwSet.IPaddress)
		output += reportService.println("Logic port number: " + session.hwSet.portNumber)
		
		output += reportService.println("Test started")
		
		String reqStr = "<?xml version=\"1.0\"?><hci-request type=\"checkConnection\"><data>12345</data></hci-request>"
		Map testReply = hciLogicCommService.getReplyToRequest(reqStr,session.hwSet.IPaddress,session.hwSet.portNumber)
		
		if(testReply['status'] == "error") {
			output += reportService.println("<span style='color:red;'>Error: " + testReply['content'] + "</span>")
		} else {
			output += reportService.println("Connection established succesfully")
			def rootNode = XML.parse(testReply['content'])
			if(rootNode.data == "12345") {
				output += reportService.println("<span style='color:green;'>Logic unit replied! The eneraptor system is set up properly.</span>")
			} else {
				output += reportService.println("<span style='color:red;'>The connection was established, but there was no reply from the logic unit.</span>")
				output += reportService.println("<span style='color:red;'>You should check the logic's port number and IP address.</span>")
				output += reportService.println("<span style='color:red;'> Returned: " + testReply['content'].encodeAsHTML() + "</span>")
				output += reportService.println("<span style='color:red;'>Should be: " + "<logic-response type=\"checkConnection\"><data>12345</data></logic-response>".encodeAsHTML() + "</span>")
			}
		}
		
		output += reportService.println("Test ended")
		
		[output:output]
		
	}
	
}
